﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using FarPoint.Web.Spread;
namespace SpreadIntro.Models
{

    [Serializable()]
    public class TimeCellType : BaseCellType
    {

        public override String Format(object o)
        {
            //if (o != null)
            //{
            //    return base.Format(o);
            //}
            return base.Format(o);
        }


        public override object GetEditorValue(Control owner, String id)
        {
            return base.GetEditorValue(owner, id);
        }
        public override Control PaintCell(string id, TableCell parent, Appearance style, Inset margin, object value, bool upperLevel)
        {
            parent.Attributes.Add("FpCellType", "TimeCellType");
            string renderKey = "TimeRenderScript";
            string editorKey = "TimeEditorScript";
            if (!parent.Page.ClientScript.IsClientScriptIncludeRegistered(renderKey))
            {
                // Register render script
                parent.Page.ClientScript.RegisterClientScriptInclude(renderKey, parent.ResolveClientUrl("~/" + renderKey + ".js"));
                // Register editor script
                parent.Page.ClientScript.RegisterClientScriptInclude(editorKey, parent.ResolveClientUrl("~/" + editorKey + ".js"));


            }
            Panel p = new Panel();
            ApplyStyleTo(parent, style, margin, upperLevel);
            p.Controls.Add(new Label() { Text = value.ToString() });
            return p;
        }
        public override Control GetEditorControl(string id, TableCell parent, Appearance style, Inset margin, object value, bool upperLevel)
        {
            // ApplyStyleTo(parent, style, margin, upperLevel);
            TextBox tb = new TextBox();
            tb.Text = value.ToString();
            if (id != null)
            {
                tb.ID = id;
            }
            //else if (parent.ClientID != null)
            //{
            //    tb.ID = parent.ClientID;
            //}
            //parent.Controls.RemoveAt(0);
            //parent.Controls.Add(tb);
            return tb;
        }
        public override object Parse(String s)
        {

            return this.ConvertStringToTime(s);

        }
        private object ConvertStringToTime(string s)
        {

            try
            {
                return TimeSpan.Parse(s);
            }
            catch (Exception e)
            {
                return "Invalid Field value !!";
            }

        }
        public String ValidateEditorValue(object val, String reason)
        {
            reason = base.ValidateEditorValue(val);
            return reason;
        }

       

        public override String EditorClientScriptUrl
        {
            get { return "~/TimeEditorScript.htc"; }
        }

        public override String RendererClientScriptUrl
        {
            get { return "~/TimeRenderScript.htc"; }
        }

    }
}