﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Collections;
using System.Collections.Specialized;
using System.Web.UI;
using System.Web.UI.WebControls;

using FarPoint.Web.Spread;
using FarPoint.PDF;
using FarPoint.Web.Spread.Editor;
using FarPoint.Web.Spread.Model;
using FarPoint.Web.Spread.Renderer;
using System.Xml;

namespace SpreadIntro
{
    /// <summary>
    /// 树形下拉框
    /// </summary>
    [Serializable()]
    public class TreeComboBoxCellType : GeneralCellType
    {
        

        /// <summary>
        /// 初始化类TreeComboBoxCellType的新实例
        /// </summary>
        public TreeComboBoxCellType(): base()
        {

        }
        TreeView view = new TreeView();
        /// <summary>
        /// 获取用于编辑单元格的控件
        /// </summary>
        /// <param name="id">控件的唯一标识符</param>
        /// <param name="parent"></param>
        /// <param name="style"></param>
        /// <param name="margin"></param>
        /// <param name="value"></param>
        /// <param name="upperLevel"></param>
        /// <returns></returns>
        public override Control GetEditorControl(string id, TableCell parent, Appearance style, Inset margin, object value, bool upperLevel)
        {
            Label label = new Label();


            view.ImageSet = TreeViewImageSet.Arrows;
            view.BorderColor = System.Drawing.Color.CadetBlue;
            view.BorderStyle = BorderStyle.Solid;
            view.BorderWidth = 1;
            view.ShowExpandCollapse = true;
            view.ShowLines = true;
            view.Attributes.Add("style", "text-align :left");
            view.Height = new Unit(250);
            view.Width = new Unit("100%");
            view.Style.Add("overflow", "auto");
            view.BackColor = System.Drawing.Color.White;
            view.Font.Size = 9;
            view.HoverNodeStyle.Font.Bold = true;
            view.HoverNodeStyle.ForeColor = System.Drawing.Color.Blue;
            view.NodeStyle.ForeColor = System.Drawing.Color.Black;


            view.Nodes.Add(new TreeNode("1"));
            view.Nodes[0].ChildNodes.Add(new TreeNode("11"));
            view.Nodes[0].ChildNodes.Add(new TreeNode("12"));
            view.Nodes.Add(new TreeNode("2"));
            view.Nodes[0].ChildNodes.Add(new TreeNode("21"));
            view.Nodes[0].ChildNodes.Add(new TreeNode("22"));
            view.Nodes[0].ChildNodes.Add(new TreeNode("23"));

            //>>CORRECT CODE
            view.LeafNodeStyle.CssClass = "TreeViewChildnode";
            view.CssClass = "TreeComboBoxCellType";
            foreach (TreeNode node in view.Nodes)
            {
                node.NavigateUrl = "#";
                foreach (TreeNode child in node.ChildNodes)
                {
                    child.NavigateUrl = "#";                    
                }
            }
            //<<CORRECT CODE

            view.ExpandAll();

            Panel panel = new Panel();
            panel.Style.Add(HtmlTextWriterStyle.Cursor, "cursor");
            label.Controls.Add(panel);
            label.Controls.Add(view);

            Panel panel2 = new Panel();
            panel2.Style.Add(HtmlTextWriterStyle.Cursor, "cursor");

            label.Controls.Add(panel2);
            label.Style.Add(HtmlTextWriterStyle.ZIndex, "999");
            if (id != null)
            {
                label.ID = id;
            }
            return label;
           
        }
        public override Control PaintCell(string id, TableCell parent, Appearance style, Inset margin, object value, bool upperLevel)
        {

            parent.Attributes.Add("FpCellType", "TreeComboCellType");
            string renderKey = "TreeComboRenderScript";
            string editorKey = "TreeComboEditorScript";
            if (!parent.Page.ClientScript.IsClientScriptIncludeRegistered(renderKey))
            {
                // Register render script
                parent.Page.ClientScript.RegisterClientScriptInclude(renderKey, parent.ResolveClientUrl("~/" + renderKey + ".js"));
                // Register editor script
                parent.Page.ClientScript.RegisterClientScriptInclude(editorKey, parent.ResolveClientUrl("~/" + editorKey + ".js"));


            }
            Panel p = new Panel();
            ApplyStyleTo(parent, style, margin, upperLevel);
            p.Controls.Add(new Label() { Text = value != null?  value.ToString() :""});
            return p;
        }
        public override object GetEditorValue(Control owner, string id)
        {
            Label lb = owner as Label;
            return (lb.Controls[1] as TreeView).SelectedNode.Text;
            // return base.GetEditorValue(owner, id);
        }
        public override String EditorClientScriptUrl
        {
            get { return "~/TreeComboRenderScript.htc"; }
        }

        public override String RendererClientScriptUrl
        {
            get { return "~/TreeComboRenderScript.htc"; }
        }
    }
}